/* auto-config.h.win32-msvc: manually created header for VC++ */


#ifndef __auto_config_h
#define __auto_config_h

/*
   All feature macros below have the default values (as defined by configure).
 */

/* Defined if alternative bayesian calculation is enabled */
#define ALT_BAYESIAN 1

/* Defined if traditional bayesian calculation is enabled */
#define BAYESIAN 1

/* Defined if bias calculations are enabled */
#define BIAS 1

/* Defined if MTA is broken */
#define BROKEN_MTA 1

/* Defined if broken-return-codes is enabled */
#undef BROKEN_RETURN_CODES

/* Defined if Chi-Square calculation is enabled */
#undef CHI_SQ

/* Defined if client-compression is enabled */
#undef CLIENT_COMPRESSION

/* Configure Argumenets */
#undef CONFIGURE_ARGS

/* Defined if debug output is enabled */
#ifdef _NDEBUG
#undef DEBUG
#elif !defined(DEBUG)
#define DEBUG 1
#endif

/* Defined if domain_scale is enabled */
#undef DOMAINSCALE

/* Defined if experimental is enabled */
#undef EXPERIMENTAL

/* Define to 1 if you have the <arpa/inet.h> header file. */
#undef HAVE_ARPA_INET_H

/* Define to 1 if you have the <dlfcn.h> header file. */
#undef HAVE_DLFCN_H

/* Define to 1 if you have the <errno.h> header file. */
#define HAVE_ERRNO_H 1

/* Define to 1 if you have the <inttypes.h> header file. */
#undef HAVE_INTTYPES_H

/* Define if you have ISO C99 vararg macros */
#undef HAVE_ISO_VARARGS

/* Define to 1 if you have the <math.h> header file. */
#define HAVE_MATH_H 1

/* Define to 1 if you have the `memcpy' function. */
#define HAVE_MEMCPY 1

/* Define to 1 if you have the <memory.h> header file. */
#define HAVE_MEMORY_H 1

/* Define to 1 if you have the `memset' function. */
#define HAVE_MEMSET 1

/* Define to 1 if you have the <netinet/in.h> header file. */
#undef HAVE_NETINET_IN_H

/* Define to 1 if you have the <stdint.h> header file. */
#undef HAVE_STDINT_H

/* Define to 1 if you have the <stdlib.h> header file. */
#define HAVE_STDLIB_H 1

/* Define to 1 if you have the <strings.h> header file. */
#undef HAVE_STRINGS_H

/* Define to 1 if you have the <string.h> header file. */
#define HAVE_STRING_H 1

/* Define to 1 if you have the `strlcpy' function. */
#undef HAVE_STRLCPY

/* Define to 1 if you have the `strsep' function. */
#undef HAVE_STRSEP

/* Define to 1 if you have the <sys/socket.h> header file. */
#undef HAVE_SYS_SOCKET_H

/* Define to 1 if you have the <sys/stat.h> header file. */
#define HAVE_SYS_STAT_H 1

/* Define to 1 if you have the <sys/time.h> header file. */
#undef HAVE_SYS_TIME_H

/* Define to 1 if you have the <sys/types.h> header file. */
#define HAVE_SYS_TYPES_H 1

/* Define to 1 if you have the <unistd.h> header file. */
#undef HAVE_UNISTD_H

/* Defined if homedir dotfiles is enabled */
#undef HOMEDIR

/* Defined if large_scale is enabled */
#undef LARGESCALE

/* Defined if long usernames is enabled */
#undef LONG_USERNAMES

/* Path to the program used as delivery agent */
#undef MLOCAL

/* Defined if neural-networking is enabled */
#undef NEURAL

/* Defined if opt-in is enabled */
#undef OPT_IN

/* Name of package */
#define PACKAGE "dspam"

/* Define to the address where bug reports for this package should be sent. */
#define PACKAGE_BUGREPORT "vz-dspam@zeitlins.org"

/* Define to the full name of this package. */
#define PACKAGE_NAME "dspam"

/* Define to the full name and version of this package. */
#undef PACKAGE_STRING

/* Define to the one symbol short name of this package. */
#undef PACKAGE_TARNAME

/* Define to the version of this package. */
#undef PACKAGE_VERSION

/* Defined if parse-to-headers is enabled */
#undef PARSE_TO

/* Path to the program used as quarantine agent */
#undef QLOCAL

/* Defined if Chi-Square calculation is enabled */
#undef ROBINSON

/* Defined if Robinson's technique for combining p-values is enabled */
#undef ROBINSON_FW

/* Defined if signature-attachments is enabled */
#undef SIGNATURE_IN_ATTACHMENTS

/* Defined if signature-headers is enabled */
#undef SIGNATURE_IN_HEADERS

/* Maximum life of server-side signatures (in days) */
#define SIGNATURE_LIFE 14

/* Defined if source address tracking is enabled */
#undef SOURCE_ADDRESS_TRACKING

/* Defined if spam-subject is enabled */
#undef SPAM_SUBJECT

/* Define to 1 if you have the ANSI C header files. */
#define STDC_HEADERS 1

/* Defined if system logging is enabled */
#undef SYSTEM_LOGGING

/* Defined if test-conditional training is enabled */
#define TEST_COND_TRAINING 1

/* Define to 1 if you can safely include both <sys/time.h> and <time.h>. */
#undef TIME_WITH_SYS_TIME

/* Defined if trusted user security are enabled */
#undef TRUSTED_USER_SECURITY

/* Defined if user logging is enabled */
#undef USER_LOGGING

/* Defined if verbose debug output is enabled */
/* #undef VERBOSE */

/* Version number of package */
#define VERSION "3.0.0..20040629.0800"

/* Defined if homedir dotfiles is enabled */
#undef VIRTUAL_USERS

/* Defined if webmail is enabled */
#undef WEBMAIL

/* Define to `__inline__' or `__inline' if that's what the C compiler
   calls it, or to nothing if 'inline' is not supported under any name.  */
#ifndef __cplusplus
/* #undef inline */
#endif


/* No config file by default under Windows */
#define CONFIG_DEFAULT "C:\\dspam.conf"

#define LOGDIR "c:\\"

#ifdef _MSC_VER
#define getpid _getpid
#define popen _popen
#define pclose _pclose
#define strcasecmp _stricmp
/*
#define strlcpy(dst, src, size) \
   strncpy((dst), (src), (size)); (dst)[(size)-1] = '\0'
*/
#define strncasecmp _strnicmp
#define strtoull _strtoui64
#define snprintf _snprintf
#define vsnprintf _vsnprintf

#define LLD_FMT_SPEC "I64d"
#define LLU_FMT_SPEC "I64u"

/*
   "conversion from 'double' to 'float', possible loss of data": this is a
   useful warning but there are simply too many of them in libdspam sources,
   so disable it.
 */
#pragma warning(disable:4244)
#endif

#endif /* !__auto_config_h */

/* vi: set ft=c: */
